Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_LRU_Caching_Strategy Class Template Reference

Defines a Least Recently Used strategy which will decide on the item to be removed from the cache. More...

`#include <Caching_Strategies_T.h>`

List of all members.

## Public Types
typedef ATTRIBUTES | CACHING_ATTRIBUTES
## Public Methods
| ACE_LRU_Caching_Strategy (void)
ATTRIBUTES | attributes (void)
| Accessor method for the timer attributes.
double | purge_percent (void)
void | purge_percent (double percentage)
int | notify_bind (int result, const ATTRIBUTES &attr)
| This method acts as a notification about the CONTAINERs bind method call.
int | notify_find (int result, ATTRIBUTES &attr)
| This method acts as a notification about the CONTAINERs find method call.
int | notify_unbind (int result, const ATTRIBUTES &attr)
| This method acts as a notification about the CONTAINERs unbind method call.
int | notify_trybind (int result, ATTRIBUTES &attr)
| This method acts as a notification about the CONTAINERs trybind method call.
int | notify_rebind (int result, const ATTRIBUTES &attr)
| This method acts as a notification about the CONTAINERs rebind method call.
CACHING_UTILITY& | caching_utility (void)
| Purge the cache.
void | dump (void) const
| Dumps the state of the object.
## Private Attributes
ATTRIBUTES | timer_
| This element is the one which is the deciding factor for purging of an ITEM.
double | purge_percent_
| The level about which the purging will happen automagically.
CACHING_UTILITY | caching_utility_
| This is the helper class which will decide and expunge entries from the cache.

## Detailed Description

### template<class ATTRIBUTES, class CACHING_UTILITY> template class ACE_LRU_Caching_Strategy

Defines a Least Recently Used strategy which will decide on the item to be removed from the cache.

This is a strategy which makes use of a virtual timer which is updated whenever an item is inserted or looked up in the container. When the need of purging entries arises, the items with the lowest timer values are removed. Explanation of the template parameter list: CONTAINER is any map with entries of type <KEY, VALUE>. The ATTRIBUTES are the deciding factor for purging of entries and should logically be included with the VALUE. Some ways of doing this are: As being a member of the VALUE or VALUE being ACE_Pair<x, ATTRIBUTES>. The CACHING_UTILITY is the class which can be plugged in and which decides the entries to purge.

## Member Typedef Documentation

template<classATTRIBUTES, classCACHING_UTILITY>
typedef ATTRIBUTES ACE_LRU_Caching_Strategy<ATTRIBUTES, CACHING_UTILITY>::CACHING_ATTRIBUTES

## Constructor & Destructor Documentation

template<classATTRIBUTES, classCACHING_UTILITY>
ACE_LRU_Caching_Strategy<ATTRIBUTES, CACHING_UTILITY>::ACE_LRU_Caching_Strategy<ATTRIBUTES, CACHING_UTILITY> ( | void )

| The <container> is the map in which the entries reside. The timer attribute is initialed to zero in this constructor. And the <purge_percent> field denotes the percentage of the entries in the cache which can be purged automagically and by default is set to 10%.

## Member Function Documentation

template<classATTRIBUTES, classCACHING_UTILITY>
ACE_INLINE ATTRIBUTES ACE_LRU_Caching_Strategy< ATTRIBUTES,CACHING_UTILITY >::attributes ( | void )

| Accessor method for the timer attributes.

template<classATTRIBUTES, classCACHING_UTILITY>
ACE_INLINE CACHING_UTILITY & ACE_LRU_Caching_Strategy< ATTRIBUTES,CACHING_UTILITY >::caching_utility ( | void )

| Purge the cache.

template<classATTRIBUTES, classCACHING_UTILITY>
ACE_INLINE void ACE_LRU_Caching_Strategy< ATTRIBUTES,CACHING_UTILITY >::dump ( | void ) const

| Dumps the state of the object.

template<classATTRIBUTES, classCACHING_UTILITY>
ACE_INLINE int ACE_LRU_Caching_Strategy< ATTRIBUTES,CACHING_UTILITY >::notify_bind ( | int result,
| const ATTRIBUTES & attr )

| This method acts as a notification about the CONTAINERs bind method call.

template<classATTRIBUTES, classCACHING_UTILITY>
ACE_INLINE int ACE_LRU_Caching_Strategy< ATTRIBUTES,CACHING_UTILITY >::notify_find ( | int result,
| ATTRIBUTES & attr )

| This method acts as a notification about the CONTAINERs find method call.

template<classATTRIBUTES, classCACHING_UTILITY>
ACE_INLINE int ACE_LRU_Caching_Strategy< ATTRIBUTES,CACHING_UTILITY >::notify_rebind ( | int result,
| const ATTRIBUTES & attr )

| This method acts as a notification about the CONTAINERs rebind method call.

template<classATTRIBUTES, classCACHING_UTILITY>
ACE_INLINE int ACE_LRU_Caching_Strategy< ATTRIBUTES,CACHING_UTILITY >::notify_trybind ( | int result,
| ATTRIBUTES & attr )

| This method acts as a notification about the CONTAINERs trybind method call.

template<classATTRIBUTES, classCACHING_UTILITY>
ACE_INLINE int ACE_LRU_Caching_Strategy< ATTRIBUTES,CACHING_UTILITY >::notify_unbind ( | int result,
| const ATTRIBUTES & attr )

| This method acts as a notification about the CONTAINERs unbind method call.

template<classATTRIBUTES, classCACHING_UTILITY>
ACE_INLINE void ACE_LRU_Caching_Strategy< ATTRIBUTES,CACHING_UTILITY >::purge_percent ( | double percentage )

template<classATTRIBUTES, classCACHING_UTILITY>
ACE_INLINE double ACE_LRU_Caching_Strategy< ATTRIBUTES,CACHING_UTILITY >::purge_percent ( | void )

## Member Data Documentation

template<classATTRIBUTES, classCACHING_UTILITY>
CACHING_UTILITY ACE_LRU_Caching_Strategy<ATTRIBUTES, CACHING_UTILITY>::caching_utility_`[private]`

| This is the helper class which will decide and expunge entries from the cache.

template<classATTRIBUTES, classCACHING_UTILITY>
double ACE_LRU_Caching_Strategy<ATTRIBUTES, CACHING_UTILITY>::purge_percent_`[private]`

| The level about which the purging will happen automagically.

template<classATTRIBUTES, classCACHING_UTILITY>
ATTRIBUTES ACE_LRU_Caching_Strategy<ATTRIBUTES, CACHING_UTILITY>::timer_`[private]`

| This element is the one which is the deciding factor for purging of an ITEM.

The documentation for this class was generated from the following files:

- Caching_Strategies_T.h
- Caching_Strategies_T.cpp
- Caching_Strategies_T.i